// Copyright (C) 2021 Terence Kelly.  All rights reserved.

#include <stddef.h>  // for NULL
#include "Ex_I.h"

int ret(void) {
  return 47;
}

int null_deref(int x) {
  int *p = NULL;
  if (x) {
    return *p + 13;  // SIGSEGV
  }
  else {
    return 47;
  }
}

int div_by_zero(int x) {
  if (x) {
    return 13 / 0;  // trap
  }
  else {
    return 47;
  }
}

int uninit(int x) {
  int u;
  if (x) {
    return u + 13;  // garbage
  }
  else {
    return 47;
  }
}

int overflow(int x) {
  if (x + 1 < x) {  // wrap
    return 13;
  }
  else {
    return 47;
  }
}
