#!/usr/bin/csh -f

# Copyright (C) 2021 Terence Kelly.  All rights reserved.

set b = Ex_IV
set flags = '-std=c17 -Wall -Wextra -pedantic -O3'
echo '--- clean up ---'
rm -f $b $b.o ${b}_main.o
echo '--- compile separately without "-flto" ---'
gcc $flags -c $b.c
gcc $flags -c ${b}_main.c
echo '--- link ---'
gcc $flags -o $b $b.o ${b}_main.o
echo '--- run executable ---'
./$b
echo '--- clean up ---'
rm -f $b $b.o ${b}_main.o
echo '--- compile separately with "-flto" ---'
gcc $flags -flto -c $b.c
gcc $flags -flto -c ${b}_main.c
echo '--- link with "-flto" ---'
gcc $flags -flto -o $b $b.o ${b}_main.o
echo '--- run executable ---'
./$b
echo '--- clean up ---'
rm -f $b $b.o ${b}_main.o
